=== debian/changelog ===
ros-kinetic-pinocchio (2.5.0-1xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Justin Carpentier <justin.carpentier@inria.fr>  Mon, 31 Aug 2020 12:08:44 -0000
